// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#include <iostream>
#include <windows.h>
#include <intrin.h>

volatile bool g_threadRun = true;
volatile bool g_switched = false;

extern "C" DWORD64 getRSP();

DWORD WINAPI threadFunc1(LPVOID lpThreadParameter)
{
    DWORD64 stackBase = __readgsqword(0x08);
    DWORD64 stackLimit = __readgsqword(0x10);
    DWORD64 rsp = getRSP();
    ::printf("threadFunc1: %d, stackBase: %p, stackLimit: %p, rsp: %p\n", GetCurrentThreadId(), stackBase, stackLimit, rsp);

    while (g_threadRun)
    {
        Sleep(1000);

        if (g_switched == true)
        {
            ::printf("[switch] threadFunc1: %d, rsp: %p\n", GetCurrentThreadId(), getRSP());
        }
    }

    return 0;
}

DWORD WINAPI threadFunc2(LPVOID lpThreadParameter)
{
    DWORD64 stackBase = __readgsqword(0x08);
    DWORD64 stackLimit = __readgsqword(0x10);
    DWORD64 rsp = getRSP();
    ::printf("threadFunc2: %d, stackBase: %p, stackLimit: %p, rsp: %p\n", GetCurrentThreadId(), stackBase, stackLimit, rsp);

    while (g_switched == false)
    {
        rsp = getRSP();
    }

    while (g_threadRun)
    {
        Sleep(1000);

        if (g_switched == true)
        {
            ::printf("[switch] threadFunc2: %d, rsp: %p\n", GetCurrentThreadId(), getRSP());
        }
    }

    return 0;
}

typedef DWORD KPRIORITY;

typedef struct _CLIENT_ID
{
    PVOID UniqueProcess;
    PVOID UniqueThread;
} CLIENT_ID, * PCLIENT_ID;

typedef struct _THREAD_BASIC_INFORMATION
{
    NTSTATUS                ExitStatus;
    PVOID                   TebBaseAddress;
    CLIENT_ID               ClientId;
    KAFFINITY               AffinityMask;
    KPRIORITY               Priority;
    KPRIORITY               BasePriority;
} THREAD_BASIC_INFORMATION, * PTHREAD_BASIC_INFORMATION;

enum THREADINFOCLASS
{
    ThreadBasicInformation,
};

// https://stackoverflow.com/questions/32297431/getting-the-tib-teb-of-a-thread-by-its-thread-handle-2015
void* GetThreadStackTopAddress(HANDLE hProcess, HANDLE hThread, /* OUT */ DWORD64* pStackBase, /* OUT */ DWORD64* pStackLimit)
{
    HMODULE module = GetModuleHandle(L"ntdll.dll");

    if (module == nullptr)
    {
        return nullptr;
    }

    NTSTATUS(__stdcall * NtQueryInformationThread)(HANDLE ThreadHandle, THREADINFOCLASS ThreadInformationClass, PVOID ThreadInformation, ULONG ThreadInformationLength, PULONG ReturnLength);
    NtQueryInformationThread = reinterpret_cast<decltype(NtQueryInformationThread)>(GetProcAddress(module, "NtQueryInformationThread"));

    if (NtQueryInformationThread)
    {
        NT_TIB tib = { 0 };
        THREAD_BASIC_INFORMATION tbi = { 0 };

        NTSTATUS status = NtQueryInformationThread(hThread, ThreadBasicInformation, &tbi, sizeof(tbi), nullptr);
        if (status >= 0)
        {
            ReadProcessMemory(hProcess, tbi.TebBaseAddress, &tib, sizeof(tbi), nullptr);

            *pStackBase = (DWORD64)tib.StackBase;
            *pStackLimit = (DWORD64)tib.StackLimit;

            return tbi.TebBaseAddress;
        }
    }

    return nullptr;
}

void SwitchStackInfoInTEB(HANDLE vCpu1, HANDLE vCpu2)
{
    DWORD64 stackBase1, stackLimit1;
    DWORD64 stackBase2, stackLimit2;
    void* teb1 = GetThreadStackTopAddress(GetCurrentProcess(), vCpu1, &stackBase1, &stackLimit1);
    void* teb2 = GetThreadStackTopAddress(GetCurrentProcess(), vCpu2, &stackBase2, &stackLimit2);

    *(DWORD64*)((BYTE*)teb1 + 0x08) = stackBase2;
    *(DWORD64*)((BYTE*)teb1 + 0x10) = stackLimit2;

    *(DWORD64*)((BYTE*)teb2 + 0x08) = stackBase1;
    *(DWORD64*)((BYTE*)teb2 + 0x10) = stackLimit1;
}

int main()
{
    HANDLE vCpu1 = ::CreateThread(nullptr, 0, threadFunc1, nullptr, 0, nullptr);
    HANDLE vCpu2 = ::CreateThread(nullptr, 0, threadFunc2, nullptr, 0, nullptr);

    Sleep(3000);
    
    ::SuspendThread(vCpu1);
    ::SuspendThread(vCpu2);

    CONTEXT ctxThread1 = { 0 };
    CONTEXT ctxThread2 = { 0 };

    ctxThread1.ContextFlags = CONTEXT_ALL;
    ctxThread2.ContextFlags = CONTEXT_ALL;

    ::GetThreadContext(vCpu1, &ctxThread1);
    ::GetThreadContext(vCpu2, &ctxThread2);

    printf("RIP1: %p, RSP: %p, GS: %d\n", ctxThread1.Rip, ctxThread1.Rsp, ctxThread1.SegGs);
    printf("RIP2: %p, RSP: %p, GS: %d\n", ctxThread2.Rip, ctxThread2.Rsp, ctxThread2.SegGs);

    //DWORD64 rsp1 = ctxThread1.Rsp;
    //ctxThread1.Rsp = ctxThread2.Rsp;
    //ctxThread2.Rsp = rsp1;

    SwitchStackInfoInTEB(vCpu1, vCpu2);

    ::SetThreadContext(vCpu2, &ctxThread1);
    ::SetThreadContext(vCpu1, &ctxThread2);

    g_switched = true;

    ::ResumeThread(vCpu1);
    ::ResumeThread(vCpu2);

    Sleep(3000);

    g_threadRun = false;
}
